--Game using engine
--by WayWardSon
--4-13-2008
System.usbDiskModeActivate()
--//colors
white = Color.new(255,255,255)
red = Color.new(255,0,0)
green = Color.new(0,255,0)
blue = Color.new(0,0,255)
black = Color.new(0,0,0)
yellow = Color.new(255,255,0)
--//loading images//--
tanks = Image.load("gfx/tanks.png")
tanks2 = Image.load("gfx/tanks2.png")
grass = Image.load("gfx/grass.png")
brush = Image.load("gfx/brush.png")
logo = Image.load("gfx/logo.png")
houses = Image.load("gfx/houses.png")
objects = Image.load("gfx/objects.png")
boat = Image.load("gfx/boat.png")
Map1 = Image.load("gfx/Map1.png")
box = Image.createEmpty(10,10)
box:clear(white)
fake = Image.createEmpty(1,1)
Bullet = Image.createEmpty(3,3)
Bullet:clear(red)
Hbar = Image.createEmpty(102,12)
Hbar:clear(Color.new(255,0,0,75))
enemy = Image.createEmpty(10,10)
enemy:clear(blue)
toolbar = Image.createEmpty(480,30)
toolbar:clear(Color.new(100,100,100))
--//SOUNDS\\--
shoot = Sound.load("sfx/shoot.wav",false)
click = Sound.load("sfx/click.wav",false)
explode = Sound.load("sfx/explode.wav",false)
--//Variables//--
game = {
	state = "main_menu";
	kills = 5;
	winner = "nil";
	map = 1
}
player = {}
player[1] = {
	x = 50;
	y = 100;
	width = 30;
	height = 30;
	img = tanks;
	imgC = 1;
	imgM = 2;
	direc = "up";
	bullets = 150;
	Sbullets = 150;
	weapon = "still";
	health = 100;
	speed = 2;
	score = 0;
	Dtime = 0;
	state = "live";
	hitcount = 0;
	percent = 0
}
player[2] = {
	x = 300;
	y = 200;
	width = 30;
	height = 30;
	img = tanks;
	imgC = 2;
	imgM = 2;
	direc = "up";
	bullets = 150;
	Sbullets = 150;
	weapon = "still";
	health = 100;
	speed = 2;
	score = 0;
	Dtime = 0;
	state = "live";
	hitcount = 0;
	percent = 0
}
bullet = {}
bullet[1] = {
	x = player[1].x + 15;
	y = player[1].y +15;
	direc = "up"
}
bullet[2] = {
	x = player[2].x + 15;
	y = player[2].y +15;
	direc = "up"
}
main_menu = {
	selec = 1;
	timer = 0;
	x = 0;
	y = 0;
	songtime = 0
}
game_options = {
	timer = 0;
	selec = 1;
	speed_selec = 2;
	songtime = 0
}
ingame = {timer = 0}
over = {
	timer = 0;
	songtime = 0
}
explodetime1 = 0
explodetime2 = 0
Boat = {x = 230,y = 350}
--//load engine//--
dofile("system/engine.lua")
dofile("system/maps.lua")
while true do
pad = Controls.read()
oldx1 = player[1].x
oldy1 = player[1].y
oldx2 = player[2].x
oldy2 = player[2].y
screen:clear()
--/////MAIN MENU\\\\-------
if game.state == "main_menu" then
--song	
	main_menu.songtime = main_menu.songtime + 1
	if main_menu.songtime < 2 then Music.playFile("sfx/menu_song.it",true) end
--end song
	main_menu.x = main_menu.x + 1
	if main_menu.x > 0 then main_menu.x = -480 end
	screen:blit(main_menu.x,main_menu.y,brush)
	screen:blit(main_menu.x+480,main_menu.y,brush)
	screen:blit(220,140,tanks,90,0,30,30)
	screen:blit(80,20,logo)
	main_menu.timer = main_menu.timer + .5 
	if main_menu.timer > 20 then main_menu.timer = 0 end
	menu_selector(3,main_menu)
	screen:fillRect(20,180,120,70,blue)
	screen:print(30,190,"START GAME",white)
	screen:print(30,210,"GAME OPTIONS",white)
	screen:print(30,230,"EXIT TO XMB",white)
	if main_menu.timer >= 0 and main_menu.timer <= 10 then 
		    if main_menu.selec == 1 then screen:print(30,190,"START GAME",red) 
		elseif main_menu.selec == 2 then screen:print(30,210,"GAME OPTIONS",red) 
		elseif main_menu.selec == 3 then screen:print(30,230,"EXIT TO XMB",red) end
	end
	if main_menu.selec == 1 and pad:cross() and not oldpad:cross() then game.state = "ingame" main_menu.songtime = 0  end
	if main_menu.selec == 2 and pad:cross() and not oldpad:cross() then game.state = "game_options" main_menu.songtime = 0 end
	if main_menu.selec == 3 and pad:cross() and not oldpad:cross() then System.Quit() end	
--/////GAME OPTIONS\\\\----
elseif game.state == "game_options" then 
screen:clear()
--song	
	game_options.songtime = game_options.songtime + 1
	if game_options.songtime < 2 then Music.playFile("sfx/carry.it",true) end
	menu_selector(7,game_options)
	screen:print(30,30,"PLAYER SPEED:",blue) 
		screen:print(170,30,"SLOW",white)
		screen:print(220,30,"NORMAL",white)
		screen:print(290,30,"FAST",white)
	screen:print(30,50,"STARTING BULLETS:",blue)
		screen:print(175,50,""..player[1].Sbullets,white)
	screen:print(30,80,"<- MAP ->",blue)
		screen:print(110,80,"#"..game.map,white)
	screen:print(30,110,"MATCH STYLE:",blue)
	screen:print(30,130,"KILLS TO WIN:",blue)
		screen:print(150,130,""..game.kills,white)
	screen:print(30,150,"TANK SELECT..P1-L, P2-R",blue)
		screen:print(50,160,"P1------P2",white)
		screen:blit(40,180,player[1].img,0,0,30,30)
		screen:blit(110,180,player[2].img,0,0,30,30)
	screen:print(30,252,"MAIN MENU",blue)
	if game_options.selec == 1 then screen:print(30,30,"PLAYER SPEED",yellow) end
	if game_options.selec == 2 then screen:print(30,50,"STARTING BULLETS",yellow) end	
	if game_options.selec == 3 then screen:print(30,80,"   MAP   ",yellow) end	
	if game_options.selec == 4 then screen:print(30,110,"MATCH STYLE",yellow) end	
	if game_options.selec == 5 then screen:print(30,130,"KILLS TO WIN",yellow) end
	if game_options.selec == 6 then screen:print(30,150,"TANK SELECT..P1-L, P2-R",yellow) end		
	if game_options.selec == 7 then screen:print(30,252,"MAIN MENU",yellow) end		
--speed selector
	if game_options.selec == 1 and pad:left() and not oldpad:left() then game_options.speed_selec = game_options.speed_selec - 1 
	elseif game_options.selec == 1 and pad:right() and not oldpad:right() then game_options.speed_selec = game_options.speed_selec + 1 
	end
		if game_options.speed_selec > 3 then game_options.speed_selec = 1 
	elseif game_options.speed_selec < 1 then game_options.speed_selec = 3 end
for a = 1,2 do	
	if game_options.speed_selec == 1 then screen:print(170,30,"SLOW",yellow) player[a].speed = 1 end
	if game_options.speed_selec == 2 then screen:print(220,30,"NORMAL",yellow) player[a].speed = 2 end	
	if game_options.speed_selec == 3 then screen:print(290,30,"FAST",yellow) player[a].speed = 3 end	
--starting bullets
	if game_options.selec == 2 and pad:left() then player[a].Sbullets = player[a].Sbullets - 1
	elseif game_options.selec == 2 and pad:right() then player[a].Sbullets = player[a].Sbullets + 1	end
		if player[a].Sbullets < 150 then player[a].Sbullets = 150 elseif player[a].Sbullets > 300 then player[a].Sbullets = 300 end
			player[a].bullets = player[a].Sbullets
end
--map selec
	if game_options.selec == 3 then 
		if pad:left() and not oldpad:left() then game.map = game.map - 1 end
		if pad:right() and not oldpad:right() then game.map = game.map + 1 end
		if game.map < 1 then game.map = 2 elseif game.map > 2 then game.map = 1 end
	end
	--print map previews...
		if game.map == 1 then screen:blit(250,130,Map1)
		elseif game.map == 2 then end
--match style
	if game_options.selec == 4 then end
--kills to win 
	if game_options.selec == 5 and pad:left() and not oldpad:left() then game.kills = game.kills - 1
	elseif game_options.selec == 5 and pad:right() and not oldpad:right() then game.kills = game.kills + 1
	end 
	if game.kills < 1 then game.kills = 10 elseif game.kills > 10 then game.kills = 1 end
--tank select
	if game_options.selec == 6 and pad:l() and not oldpad:l() then player[1].imgC = player[1].imgC + 1 end
	if game_options.selec == 6 and pad:r() and not oldpad:r() then player[2].imgC = player[2].imgC + 1 end	
			for a = 1,2 do
		if player[a].imgC > player[a].imgM then player[a].imgC = 1 elseif player[a].imgC < 1 then player[a].imgC = player[a].imgM end
				if player[a].imgC == 1 then player[a].img = tanks
				elseif player[a].imgC == 2 then player[a].img = tanks2 end
			end
--back to main menu 
	if game_options.selec == 7 and pad:cross() and not oldpad:cross() then game.state = "main_menu" game_options.songtime = 0 end
----//////IN GAME\\\----	
elseif game.state == "ingame" then 
ingame.timer = ingame.timer +1
if game.map == 1 and ingame.timer < 2 then Music.playFile("sfx/map1.it",true) end

	if player[1].state == "live" and game.state == "ingame" then 
	player1_mov()
		bullet_setup_1()
	elseif player[1].state == "dead" and game.state == "ingame" then

	end
	if player[2].state == "live" and game.state == "ingame" then 
	player2_mov()
		bullet_setup_2()
	elseif player[2].state == "dead" and game.state == "ingame" then 
 
end
map_select()	
	player1_collision(player[2].x,player[2].y,30,30)
	player2_collision(player[1].x,player[1].y,30,30)

	screen:blit(bullet[1].x,bullet[1].y,Bullet)
	screen:blit(bullet[2].x,bullet[2].y,Bullet)		
	if player[1].state == "live" then
	player_images_1() 
--bullet collision with tanks
		bullet_obj_col_2_hit(player[1].x,player[1].y,30,30)		
	end
	if player[2].state == "live" then
	player_images_2() 
		bullet_obj_col_1_hit(player[2].x,player[2].y,30,30)	
	end
--shoot test
	if pad:l() and not oldpad:l() then tank_shoot_1() end
	if pad:r() and not oldpad:r() then tank_shoot_2() end	
	--debug_info
--	screen:print(300,0,"X:"..player[1].x,white)
--	screen:print(300,10,"Y:"..player[1].y,white)
--	screen:print(300,20,"Direc:"..player[1].direc,white)
--	screen:print(300,30,"Bullets:"..player[1].bullets,blue)
--	screen:print(300,40,"state:"..player[1].weapon,white)



	player_info()
	score()
	dying()
	if player[1].state == "dead" then explode_1() end
	if player[2].state == "dead" then explode_2() end
	-----round draw
--////OVER GAME STATE\\\---
elseif game.state == "over" then 
--song	
	over.songtime = over.songtime + 1
	if over.songtime < 2 then Music.playFile("sfx/over.it",true) end
	screen:clear()
screen:print(170,50,"Winner: "..game.winner,yellow)
screen:print(170,70,"P1-----------P2",white)
--kills
screen:fillRect(0,99,350,11,blue)
screen:print(10,100,"KILLS-",yellow)
	screen:print(170,100,""..player[1].score,red)
	screen:print(280,100,""..player[2].score,red)
--Bullets shot
screen:fillRect(0,119,350,11,blue)
screen:print(10,120,"Bullets Shot-",yellow)
	screen:print(170,120,""..player[1].Sbullets-player[1].bullets,red)
	screen:print(280,120,""..player[2].Sbullets-player[2].bullets,red)	
--Bullets Hit
screen:fillRect(0,139,350,11,blue)
screen:print(10,140,"Bullets Hit-",yellow)
	screen:print(170,140,""..player[1].hitcount,red)
	screen:print(280,140,""..player[2].hitcount,red)
--Bullets Left
screen:fillRect(0,159,350,11,blue)
screen:print(10,160,"Bullets Left-",yellow)
	screen:print(170,160,""..player[1].bullets,red)
	screen:print(280,160,""..player[2].bullets,red)
--Hit Acuracy
screen:fillRect(0,179,350,11,blue)
screen:print(10,180,"Hit Acuracy-",yellow)
	screen:print(170,180,""..player[1].percent.."%",red)
	screen:print(280,180,""..player[2].percent.."%",red)
	player[1].percent = math.floor((player[1].hitcount) / (player[1].Sbullets-player[1].bullets) * 100)
	player[2].percent = math.floor((player[2].hitcount) / (player[2].Sbullets-player[2].bullets) * 100)
--return to main menu..
over.timer = over.timer +.5 
if over.timer > 20 then over.timer = 0 end
if over.timer > 0 and over.timer < 10 then 
screen:print(170,250,"press start",red)
else end
	if pad:start() and not oldpad:start() then 
		game.state = "main_menu" 
		over.songtime = 0
			for a = 1,2 do
		player[a].bullets = player[1].Sbullets
		player[a].score = 0
		player[a].hitcount = 0
		player[a].percent = 0
		player[a].health = 100
		player[a].Dtime = 0
		player[a].state = "live"
		player[a].Sbullets = 150
		game.kills = 5
		game.map = 1
		player[a].speed = 2
		player[1].imgC = 1
		player[2].imgC = 2
			end
	end

end
screen.waitVblankStart()
oldpad = pad
screen.flip()
--if pad:select() then screen:save("screen.png") end
end 